var	gTodaysMoon, gTodaysPhase;
//var	gFutureMoons = {};
//var gFuturePhases = {};
var gCycleDays = 29.530589;
var gMillisecondsPerDay = 24 * 60 * 60 * 1000;
var gCycleMilliseconds = gCycleDays * gMillisecondsPerDay;
var	gNewMoonDate = Date.UTC(2007, 3 - 1, 19, 2, 43);
var gRiseTime, gSetTime;
var	gFirstDayOfWeek = 0; // Sunday

function FullMoon_OnLoad()
{
	gTodaysMoon = background.addImageObject("FullMoon.png", 14, 3);
	gTodaysMoon.width = 96;
	gTodaysMoon.height = 96;
	
	gTodaysPhase = background.addImageObject("Phase14Mask.png", 14, 3);
	gTodaysPhase.width = 96;
	gTodaysPhase.height = 96;
	
	/*
	var vLeft = 80;
	var vTop = -18;
	
	for (vIndex = 0; vIndex < 4; ++vIndex)
	{
		gFutureMoons[vIndex] = FullMoon_AddMoon();
		gFuturePhases[vIndex] = FullMoon_AddPhaseMask();

		gFutureMoons[vIndex].top = vTop;
		gFutureMoons[vIndex].left = vLeft;
		
		gFuturePhases[vIndex].top = vTop;
		gFuturePhases[vIndex].left = vLeft;
		
		// vLeft = vLeft + 25;
		vTop = vTop + 22;
	}
	*/
	/*
	gTestText = background.addTextObject("000000000000\r\n000000000000", "Calibri", 18, "White", 10, 10);
	gTestText.addGlow("Black", 2, 100);
	gTestText.value = String(gNewMoonDate) + "\r\nLine 2";
	*/
	/*
	gRiseTime = background.addTextObject("3:45am", "Calibri", 14, "White", 70, 10);
	gRiseTime.addGlow("Black", 2, 100);
	gSetTime = background.addTextObject("8:45pm", "Calibri", 14, "White", 70, 30);
	gSetTime.addGlow("Black", 2, 100);
	*/
	//
	
	FullMoon_UpdatePhases();
	
	setInterval("FullMoon_UpdatePhases()", 15 * 60 * 1000);
}

function FullMoon_AddMoon()
{
	var	vMoon;
	
	vMoon = background.addImageObject("FullMoon.png", 0, 0);
	
	vMoon.width = 20;
	vMoon.height = 20;
	
	return vMoon;
}

function FullMoon_AddPhaseMask()
{
	var	vMoon;
	
	vMoon = background.addImageObject("Phase0Mask.png", 0, 0);
	
	vMoon.width = 20;
	vMoon.height = 20;
	
	return vMoon;
}

function FullMoon_UpdatePhases()
{
	var	vCurrentDate = new Date();
	var	vCycle = (vCurrentDate.getTime() - gNewMoonDate) / gCycleMilliseconds;
	
	FullMoon_SetPhaseMask(gTodaysPhase, vCycle);
	/*
	for (vIndex = 0; vIndex < 4; ++vIndex)
		FullMoon_SetPhaseMask(gFuturePhases[vIndex], vCycle + (1 + 2 * vIndex) / gCycleDays);
	*/
}

function FullMoon_SetPhaseMask(pPhaseMask, pPhase)
{
	var vPhase = pPhase - Math.floor(pPhase);
	
	var vPhaseAngle = vPhase * 2.0 * Math.PI;
	var	vCosPhaseAngle = Math.cos(vPhaseAngle);
	
	if (vPhase >= 0.5)
		vCosPhaseAngle = -2.0 - vCosPhaseAngle;
	
	vCosPhaseAngle = (1.0 - vCosPhaseAngle) * 0.25;
	
	var vCycleIndex = Math.floor(vCosPhaseAngle * 64 + 0.5);
	
	if (vCycleIndex == 64)
		vCycleIndex = 0;
	
	if (vCycleIndex <= 32)
	{
		pPhaseMask.src = "Phase" + vCycleIndex + "Mask.png";
		pPhaseMask.rotation = 0;
	}
	else
	{
		pPhaseMask.src = "Phase" + (64 - vCycleIndex) + "Mask.png";
		pPhaseMask.rotation = 180;
	}
}

function FullMoon_ShowCalendar()
{
	if (System.Gadget.Flyout.show)
		System.Gadget.Flyout.show = false;
	else
	{
		System.Gadget.Flyout.file = "Calendar.html";
		System.Gadget.Flyout.show = true;
	}
}

function Calendar(pBackground)
{
	this.Background = pBackground;
	
	this.CellWidth = 28;
	this.CellHeight = 28;
	this.ImageWidth = 24;
	this.ImageHeight = 24;
	this.GridTop = 37;
	
	this.SetMonthView = function(pMonth, pYear)
	{
		this.Background.removeObjects();
		
		var	vDisplayDate = new Date(pYear, pMonth, 1);
		var	vCurrentDate = new Date();
		
		//
		
		this.Background.addTextObject(GetLongMonthName(pMonth) + " " + pYear, "Calibri", 18, "White", 5, 4);
		/*
		var	vPrevMonthButton = this.Background.addImageObject("LeftArrow.png", 160, 9);
		var	vNextMonthButton = this.Background.addImageObject("RightArrow.png", 180, 9);
		*/
		//
		
		var	vDate = new Date(pYear, pMonth, 1 - vDisplayDate.getDay() + gFirstDayOfWeek);
		var	vCycle = (vDate.getTime() - gNewMoonDate) / gCycleMilliseconds;
		var	vCycleIncr = 1.0 / gCycleDays;
		
		for (var vColumn = 0; vColumn < 7; ++vColumn)
		{
			var	vLeft = vColumn * this.CellWidth + 6;
			var	vText = this.Background.addTextObject(GetShortWeekdayName(vColumn + 1), "Calibri", 10, "White", vLeft + 4, this.GridTop - 10);
		}
		
		for (var vRow = 0; vRow < 5; ++vRow)
		{
			var	vTop = vRow * this.CellHeight + 4 + this.GridTop;
			
			for (var vColumn = 0; vColumn < 7; ++vColumn)
			{
				var	vLeft = vColumn * this.CellWidth + 6;
				
				var vImage = this.Background.addImageObject("FullMoon.png", vLeft - 36, vTop - 34);
				
				vImage.width = this.ImageWidth;
				vImage.height = this.ImageHeight;
				
				var	vMask = this.Background.addImageObject("Phase0Mask.png", vLeft - 36, vTop - 34);

				vMask.width = this.ImageWidth;
				vMask.height = this.ImageHeight;
				
				FullMoon_SetPhaseMask(vMask, vCycle);
				
				var vColor;
				
				if (vDate.getMonth() == pMonth)
				{
					if (vDate.getMonth() == vCurrentDate.getMonth()
					&& vDate.getDate() == vCurrentDate.getDate()
					&& vDate.getYear() == vCurrentDate.getYear())
						vColor = "Yellow";
					else
						vColor = "White";
				}
				else
				{
					vColor = "Color(255, 192, 192, 192)";
					vImage.opacity = 50;
					vMask.opacity = 50;
				}
				
				var	vText = this.Background.addTextObject(vDate.getDate(), "Calibri", 10, vColor, vLeft, vTop);
				
				vText.addGlow("Color(255, 0, 0, 0)", 1, 70);
				
				vCycle += vCycleIncr;
				
				vDate.setDate(vDate.getDate() + 1);
			}
		}
	};

	this.NextMonth = function()
	{
		this.Date.setMonth(this.Date.getMonth() + 1);
		
		this.SetMonthView(this.Date.getMonth(), this.Date.getYear());
	}
	
	this.PreviousMonth = function()
	{
		this.Date.setMonth(this.Date.getMonth() - 1);
		
		this.SetMonthView(this.Date.getMonth(), this.Date.getYear());
	}
	
	this.Date = new Date();
	this.SetMonthView(this.Date.getMonth(), this.Date.getYear());
}

function MoonCalendar_Initialize(pCalendarDIV)
{
	gCalendar = new Calendar(MoonCalendar);
}
